VERSION 2.00
Begin Form Hurricane 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Hurricane Tracker"
   ClientHeight    =   4080
   ClientLeft      =   360
   ClientTop       =   1890
   ClientWidth     =   8400
   Height          =   4485
   Icon            =   HURRICAN.FRX:0000
   KeyPreview      =   -1  'True
   Left            =   300
   LinkTopic       =   "Form1"
   ScaleHeight     =   4080
   ScaleWidth      =   8400
   Top             =   1545
   Width           =   8520
   Begin CommandButton Command1 
      Caption         =   "Instant Update..."
      Height          =   375
      Left            =   3120
      TabIndex        =   1
      Top             =   120
      Width           =   2175
   End
   Begin IPPORT IPPort1 
      EOL             =   ""
      InBufferSize    =   2048
      Left            =   480
      Linger          =   -1  'True
      LocalPort       =   0
      OutBufferSize   =   2048
      Port            =   0
      Top             =   120
   End
   Begin Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   1080
      Top             =   120
   End
   Begin TextBox tResponse 
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "Terminal"
      FontSize        =   9
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   3375
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   600
      Width           =   8175
   End
End
'Post-scaler for timer (timer can only count
' up to 32767 ms, so this is necessary for
' periodic updates of more than 32.8 seconds
' or so)
Dim Seconds As Long

Sub Command1_Click ()
Poll
End Sub

Sub Form_KeyPress (KeyAscii As Integer)
KeyAscii = 0
End Sub

Sub Form_Load ()
Show
Poll
End Sub

Sub IPPort1_Connected (StatusCode As Integer, Description As String)

tResponse.Text = ""

If Description <> "OK" Then
    MsgBox "Connection error: " & Description
    End
End If

End Sub

Sub IPPort1_DataIn (Text As String, EOL As Integer)

If EOL Then Text = Text & Chr$(13) & Chr$(10)

tResponse.SelStart = Len(tResponse.Text)
tResponse.SelText = Text

End Sub

Sub IPPort1_Disconnected (StatusCode As Integer, Description As String)

If Description <> "OK" Then
    MsgBox "Connection broken: " & Description
End If
End Sub

Sub Poll ()
'Don't re-enter with button
Command1.Enabled = False

'Turn off periodic timer and reset its post-scaler
Timer1.Enabled = False
Seconds = 0

On Error GoTo ErrorHandler

IPPort1.EOL = Chr$(10)
'Close old connection, if any
IPPort1.Connected = False
IPPort1.HostName = "wx.atmos.uiuc.edu"
IPPort1.Port = 70 'Gopher
IPPort1.Connected = True

'Wait until we are connected
Do Until IPPort1.Connected: DoEvents: Loop

tResponse.Text = "Polling gopher server...." & Chr$(13) & Chr$(10)

'Send request
IPPort1.DataToSend = "0/Hurricane Advisories and Images/Atlantic-Discussion" & Chr$(10)

Timer1.Enabled = True 'Allow timer to trigger again
Command1.Enabled = True 'Allow button to trigger again
Exit Sub

ErrorHandler:
    MsgBox "Could not access weather server: " & Error$
    IPPort1.Connected = False
    End
End Sub

Sub Timer1_Timer ()
If Seconds >= 60 * 15 Then
  Poll
Else
  Seconds = Seconds + 1
End If
End Sub

Sub tResponse_KeyPress (KeyAscii As Integer)
KeyAscii = 0
End Sub

